// Sample7_ExternalInterfaceDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sample7_ExternalInterface.h"
#include "Sample7_ExternalInterfaceDlg.h"
#include ".\sample7_externalinterfacedlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSample7_ExternalInterfaceDlg dialog



CSample7_ExternalInterfaceDlg::CSample7_ExternalInterfaceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSample7_ExternalInterfaceDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSample7_ExternalInterfaceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSample7_ExternalInterfaceDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_SITE, OnBnClickedSite)
	ON_BN_CLICKED(ID_ORDER, OnBnClickedOrder)
	ON_BN_CLICKED(ID_CALL_ACTION_SCRIPT_FUNCTION, OnBnClickedCallActionScriptFunction)
END_MESSAGE_MAP()


// CSample7_ExternalInterfaceDlg message handlers

BOOL CSample7_ExternalInterfaceDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	// FlashPlayerControl creating
	// NOTE: CALL RegisterFlashWindowClass() or RegisterFlashWindowClassEx() before creating!
	// See InitInstance() implementation
	{
		RECT rc;
		GetDlgItem(IDC_STATIC_FPC_PLACE)->GetWindowRect(&rc);
		ScreenToClient(&rc);

		m_hwndFlashPlayerControl = 
			CreateWindow(WC_FLASH, 
						 NULL, 
						 WS_CHILD | WS_VISIBLE, 
						 rc.left, 
						 rc.top, 
						 rc.right - rc.left, 
						 rc.bottom - rc.top, 
						 m_hWnd, 
						 NULL, 
						 NULL, 
						 NULL);
	}

	// Load movie from resource
	FPCPutMovieFromResource(m_hwndFlashPlayerControl, 0, _T("MOVIE"), _T("SWF"));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSample7_ExternalInterfaceDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSample7_ExternalInterfaceDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSample7_ExternalInterfaceDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSample7_ExternalInterfaceDlg::OnBnClickedCallActionScriptFunction()
{
	TCHAR szResponse[1024] = { 0 };
	DWORD dwLength = sizeof(szResponse) / sizeof(szResponse[0]) - 1;
	FPCCallFunction(m_hwndFlashPlayerControl, 
					_T("<invoke name=\"CallMeFromApplication\" returntype=\"xml\"><arguments><string>Some text for FlashPlayerControl</string></arguments></invoke>"), 
					szResponse, 
					&dwLength);
	AfxMessageBox(CString(_T("The function returned: ")) + szResponse);
}

void CSample7_ExternalInterfaceDlg::OnBnClickedSite()
{
	ShellExecute(m_hWnd, NULL, _T("http://www.flashplayercontrol.com/dll/"), NULL, NULL, SW_SHOW);
}

void CSample7_ExternalInterfaceDlg::OnBnClickedOrder()
{
	ShellExecute(m_hWnd, NULL, _T("http://www.flashplayercontrol.com/dll/order.html"), NULL, NULL, SW_SHOW);
}

LRESULT CSample7_ExternalInterfaceDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
    if (WM_NOTIFY == message)
    {
        LPNMHDR lpNMHDR = (LPNMHDR)lParam;

        if (m_hwndFlashPlayerControl == lpNMHDR->hwndFrom)
            switch (lpNMHDR->code)
            {
				case FPCN_FLASHCALL:
                {
					SFPCFlashCallInfoStruct* pInfo = (SFPCFlashCallInfoStruct*)lParam;

					CString str;
					str += _T("The request is: '");
					str += pInfo->request;
					str += _T("'");

					AfxMessageBox(str);

					COleDateTime now = COleDateTime::GetCurrentTime();
					FPCSetReturnValue(m_hwndFlashPlayerControl, 
									  _T("<string>Current time is: ") + 
									  now.Format() + 
									  _T("\r\nThis info is returned from the handler</string>"));

                    return 1;
                }
			}
	}

	return CDialog::WindowProc(message, wParam, lParam);
}
